// GL.c 
//  [-lglu32 -lopengl32 ]
//ļ
#include "GL.h"

HGLRC           hRC=NULL;   // ɫ
HDC             hDC=NULL;   // OpenGLȾ
HWND            hWnd=NULL;  // ǵĴھ
HINSTANCE       hInstance;  // ʵ
int             keys[256];  // ̰
int             active=TRUE;    // ڵĻ־ȱʡΪTRUE
int             fullscreen=FALSE;   // ȫ־ȱʡȱʡ趨ȫģʽ
GLfloat         rtri;   // εĽǶ

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);   // WndProcĶ

GLvoid ReSizeGLScene(GLsizei width, GLsizei height)
{
	if (height==0) // ֹ
	{
		height=1;
	}

	glViewport(0, 0, width, height);    // õǰӿ
	glMatrixMode(GL_PROJECTION);    // ѡͶӰ
	glLoadIdentity();   // ͶӰ
	// ӿڵĴС
	gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,0.1f,100.0f);
	glMatrixMode(GL_MODELVIEW);     // ѡģ͹۲
	glLoadIdentity();   // ģ͹۲
}

int InitGL(GLvoid)
{
	glShadeModel(GL_SMOOTH);    // Ӱƽ
	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);   // ɫ
	glClearDepth(1.0f);     // Ȼ
	glEnable(GL_DEPTH_TEST);    // Ȳ
	glDepthFunc(GL_LEQUAL);     // ȲԵ
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);  // ϵͳ͸ӽ
	return TRUE;    // ʼ OK
}

int DrawGLScene(GLvoid)
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);     // ĻȻ
	glLoadIdentity();   // õǰģ͹۲

	glTranslatef(-1.5f,0.0f,-6.0f);     //  1.5 λĻ 6.0

	glRotatef(rtri,0.0f,1.0f,0.0f);     // Yת

	glBegin(GL_TRIANGLES);      // ʼƽĸ
		glColor3f(1.0f,0.0f,0.0f);      // ɫ
		glVertex3f( 0.0f, 1.0f, 0.0f);      // ε϶ (ǰ)
		glColor3f(0.0f,1.0f,0.0f);      // ɫ
		glVertex3f(-1.0f,-1.0f, 1.0f);      // ε¶ (ǰ)
		glColor3f(0.0f,0.0f,1.0f);      // ɫ
		glVertex3f( 1.0f,-1.0f, 1.0f);      // ε¶ (ǰ)

		glColor3f(1.0f,0.0f,0.0f);      // ɫ
		glVertex3f( 0.0f, 1.0f, 0.0f);  // ε϶ (Ҳ)
		glColor3f(0.0f,0.0f,1.0f);      // ɫ
		glVertex3f( 1.0f,-1.0f, 1.0f);      // ε¶ (Ҳ)
		glColor3f(0.0f,1.0f,0.0f);      // ɫ
		glVertex3f( 1.0f,-1.0f, -1.0f); // ε¶ (Ҳ)

		glColor3f(1.0f,0.0f,0.0f);      // ɫ
		glVertex3f( 0.0f, 1.0f, 0.0f);      // ε϶ ()
		glColor3f(0.0f,1.0f,0.0f);      // ɫ
		glVertex3f( 1.0f,-1.0f, -1.0f);     // ε¶ ()
		glColor3f(0.0f,0.0f,1.0f);      // ɫ
		glVertex3f(-1.0f,-1.0f, -1.0f);     // ε¶ ()

		glColor3f(1.0f,0.0f,0.0f);      // ɫ
		glVertex3f( 0.0f, 1.0f, 0.0f);      // ε϶ ()
		glColor3f(0.0f,0.0f,1.0f);      // ɫ
		glVertex3f(-1.0f,-1.0f,-1.0f);  // ε¶ ()
		glColor3f(0.0f,1.0f,0.0f);      // ɫ
		glVertex3f(-1.0f,-1.0f, 1.0f);      // ε¶ ()
	glEnd();        // ƽ
	rtri+=0.2f;
	return TRUE;
}

GLvoid KillGLWindow(GLvoid)
{
	if (fullscreen)     // Ǵȫģʽ?
	{
		ChangeDisplaySettings(NULL,0);					// ǵĻл
		ShowCursor(TRUE);						// ʾָ
	}
	if (hRC)								// ӵOpenGLȾ?
	{
		if (!wglMakeCurrent(NULL,NULL))					// ܷͷDCRC?
		{
			MessageBox(NULL,"ͷDCRCʧܡ","رմ",MB_OK | MB_ICONINFORMATION);
		}

		if (!wglDeleteContext(hRC))					// ܷɾRC?
		{
			MessageBox(NULL,"ͷRCʧܡ","رմ",MB_OK | MB_ICONINFORMATION);
		}
		hRC=NULL;							// RCΪ NULL
	}

	if (hDC && !ReleaseDC(hWnd,hDC))					// ܷͷ DC?
	{
		MessageBox(NULL,"ͷDCʧܡ","رմ",MB_OK | MB_ICONINFORMATION);
		hDC=NULL;							//  DC Ϊ NULL
	}

	if (hWnd && !DestroyWindow(hWnd))					// ܷٴ?
	{
		MessageBox(NULL,"ͷŴھʧܡ","رմ",MB_OK | MB_ICONINFORMATION);
		hWnd=NULL;							//  hWnd Ϊ NULL
	}

	if (!UnregisterClass("GL",hInstance))				// ܷע?
	{
		MessageBox(NULL,"עࡣ","رմ",MB_OK | MB_ICONINFORMATION);
		hInstance=NULL;							//  hInstance Ϊ NULL
	}
}

int CreateGLWindow(const char* title, int width, int height, int fullscreenflag)
{

	GLuint		PixelFormat;						// ƥĽ
	WNDCLASS	wc;							// ṹ
	DWORD		dwExStyle;						// չڷ
	DWORD		dwStyle;						// ڷ
	RECT WindowRect;							// ȡþεϽǺ½ǵֵ
	WindowRect.left=(long)0;						// Left   Ϊ 0
	WindowRect.right=(long)width;						// Right  ΪҪĿ
	WindowRect.top=(long)0;							// Top    Ϊ 0
	WindowRect.bottom=(long)height;						// Bottom ΪҪĸ߶

	fullscreen=fullscreenflag;						// ȫȫ־

	hInstance		= GetModuleHandle(NULL);			// ȡǴڵʵ
	wc.style		= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;		// ƶʱػΪȡDC
	wc.lpfnWndProc		= (WNDPROC) WndProc;				// WndProcϢ
	wc.cbClsExtra		= 0;						// ޶ⴰ
	wc.cbWndExtra		= 0;						// ޶ⴰ
	wc.hInstance		= hInstance;					// ʵ
	wc.hIcon		= LoadIcon(NULL, IDI_WINLOGO);			// װȱʡͼ
	wc.hCursor		= LoadCursor(NULL, IDC_ARROW);			// װָ
	wc.hbrBackground	= NULL;						// GLҪ
	wc.lpszMenuName		= NULL;						// Ҫ˵
	wc.lpszClassName	= "GL";					// 趨

	if (!RegisterClass(&wc))						// עᴰ
	{
		MessageBox(NULL,"עᴰʧ","",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;							// ˳FALSE
	}

	if (fullscreen)								// Ҫȫģʽ?
	{
		DEVMODE dmScreenSettings;						// 豸ģʽ
		memset(&dmScreenSettings,0,sizeof(dmScreenSettings));			// ȷڴΪ
		dmScreenSettings.dmSize=sizeof(dmScreenSettings);			// Devmode ṹĴС
		dmScreenSettings.dmPelsWidth	= width;				// ѡĻ
		dmScreenSettings.dmPelsHeight	= height;				// ѡĻ߶
		dmScreenSettings.dmBitsPerPel	= 32;					// ÿѡɫ
		dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;
		// ʾģʽؽע: CDS_FULLSCREEN ȥ״̬
		if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)
		{
			// ģʽʧܣṩѡ˳ڴС
			if (MessageBox(NULL,"ȫģʽڵǰԿʧܣ\nʹôģʽ","NeHe G",MB_YESNO|MB_ICONEXCLAMATION)==IDYES)
			{
				fullscreen=FALSE;				// ѡ񴰿ģʽ(Fullscreen=FALSE)
			}
			else
			{
				// һԻ򣬸û
				MessageBox(NULL,"򽫱ر","",MB_OK|MB_ICONSTOP);
				return FALSE;					//  ˳ FALSE
			}
		}
	}

	if (fullscreen)								// Դȫģʽ?
	{
		dwExStyle=WS_EX_APPWINDOW;					// չ
		dwStyle=WS_POPUP;						// 
		ShowCursor(FALSE);						// ָ
	}
	else
	{
		dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;			// չ
		dwStyle=WS_OVERLAPPEDWINDOW;					//  
	}
	
	AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);		// ڴﵽҪĴС
	if (!(hWnd=CreateWindowEx(	dwExStyle,				// չ
					"GL",				// 
					title,					// ڱ
					WS_CLIPSIBLINGS |			// Ĵ
					WS_CLIPCHILDREN |			// Ĵ
					dwStyle,				// ѡĴ
					0, 0,					// λ
					WindowRect.right-WindowRect.left,	// õĴڿ
					WindowRect.bottom-WindowRect.top,	// õĴڸ߶
					NULL,					// ޸
					NULL,					// ޲˵
					hInstance,				// ʵ
					NULL)))					// WM_CREATEκζ

	{
		KillGLWindow();							// ʾ
		MessageBox(NULL,"ܴһ豸","",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;							//  FALSE
	}

	static	PIXELFORMATDESCRIPTOR pfd=					// /pfd ߴϣĶʹõظʽ
	{
		sizeof(PIXELFORMATDESCRIPTOR),					// ʽĴС
		1,								// 汾
		PFD_DRAW_TO_WINDOW |						// ʽִ֧
		PFD_SUPPORT_OPENGL |						// ʽ֧OpenGL
		PFD_DOUBLEBUFFER,						// ֧˫
		PFD_TYPE_RGBA,							//  RGBA ʽ
		32,								// ѡɫ
		0, 0, 0, 0, 0, 0,						// Եɫλ
		0,								// Alpha
		0,								// Shift Bit
		0,								// ۼӻ
		0, 0, 0, 0,							// Ծۼλ
		16,								// 16λ Z- (Ȼ)
		0,								// ɰ建
		0,								// ޸
		PFD_MAIN_PLANE,							// ͼ
		0,								// Reserved
		0, 0, 0								// Բ
	};

	if (!(hDC=GetDC(hWnd)))							// ȡ豸ô?
	{
		KillGLWindow();							// ʾ
		MessageBox(NULL,"ܴһƥظʽ","",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;							//  FALSE
	}

	if (!(PixelFormat=ChoosePixelFormat(hDC,&pfd)))				// Windows ҵӦظʽ?
	{
		KillGLWindow();							// ʾ
		MessageBox(NULL,"ظʽ","",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;							//  FALSE
	}
	
	if(!SetPixelFormat(hDC,PixelFormat,&pfd))				// ܹظʽô?
	{
		KillGLWindow();							// ʾ
		MessageBox(NULL,"ظʽ","",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;							//  FALSE
	}

	if (!(hRC=wglCreateContext(hDC)))					// ܷȡɫ?
	{
		KillGLWindow();							// ʾ
		MessageBox(NULL,"ܴOpenGLȾ","",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;							//  FALSE
	}

	if(!wglMakeCurrent(hDC,hRC))						// Լɫ
	{
		KillGLWindow();							// ʾ
		MessageBox(NULL,"ܼǰOpenGLȻ","",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;							//  FALSE
	}

	ShowWindow(hWnd,SW_SHOW);						// ʾ
	SetForegroundWindow(hWnd);						// ȼ
	SetFocus(hWnd);								// ü̵Ľ˴
	ReSizeGLScene(width, height);						// ͸ GL Ļ

	if (!InitGL())								// ʼ½GL
	{
		KillGLWindow();							// ʾ
		MessageBox(NULL,"ʼGLʧ.","",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;							//  FALSE
	}

	return TRUE;								// ɹ
}

LRESULT CALLBACK WndProc(	HWND	hWnd,					// ڵľ
				UINT	uMsg,					// ڵϢ
				WPARAM	wParam,					// ӵϢ
				LPARAM	lParam)					// ӵϢ
{

	switch (uMsg)								// WindowsϢ
	{
		case WM_ACTIVATE:						// ӴڼϢ
		{
			if (!HIWORD(wParam))					// С״̬
			{
				active=TRUE;					// ڼ״̬
			}
			else
			{
				active=FALSE;					// ټ
			}

			return 0;						// Ϣѭ
		}
		case WM_SYSCOMMAND:						// ϵͳж
		{
			switch (wParam)						// ϵͳ
			{
				case SC_SCREENSAVE:				// Ҫ?
				case SC_MONITORPOWER:				// ʾҪڵģʽ?
				return 0;					// ֹ
			}
			break;							// ˳
		}
		case WM_CLOSE:							// յCloseϢ?
		{
			PostQuitMessage(0);					// ˳Ϣ
			return 0;						// 
		}
		case WM_KEYDOWN:						// мô?
		{
			keys[wParam] = TRUE;					// ǣΪTRUE
			return 0;						// 
		}
		case WM_KEYUP:							// мſô?
		{
			keys[wParam] = FALSE;					// ǣΪFALSE
			return 0;						// 
		}
		case WM_SIZE:							// OpenGLڴС
		{
			ReSizeGLScene(LOWORD(lParam),HIWORD(lParam));		// LoWord=Width,HiWord=Height
			return 0;						// 
		}
	}
	//  DefWindowProcδϢ
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}

int WINAPI WinMain(	HINSTANCE	hInstance,				// ǰʵ
			HINSTANCE	hPrevInstance,				// ǰһʵ
			LPSTR		lpCmdLine,				// в
			int		nCmdShow)				// ʾ״̬
{
	MSG	msg;								// WindowsxϢṹ
	BOOL	done=FALSE;							// ˳ѭBool 
	// ʾûѡģʽ
	if (MessageBox(NULL,"ȫģʽô", "ȫģʽ",MB_YESNO|MB_ICONQUESTION)==IDNO)
	{
		fullscreen=FALSE;						// FALSEΪģʽ
	}
    else
    {
		fullscreen=TRUE;
    }
	// OpenGL
	if (!CreateGLWindow("OpenGL",640,480,fullscreen))
	{
		return 0;							// ʧ˳
	}
	
	while(!done)								// ѭֱ done=TRUE
	{
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))			// Ϣڵȴ?
		{
			if (msg.message==WM_QUIT)				// յ˳Ϣ?
			{
				done=TRUE;					// ǣdone=TRUE
			}
			else							// ǣϢ
			{
				TranslateMessage(&msg);				// Ϣ
				DispatchMessage(&msg);				// Ϣ
			}
		}
		else								// ûϢ
		{
			// ƳESCDrawGLScene()˳Ϣ
			if (active)						// 򼤻ô?
			{
				if (keys[VK_ESCAPE])				// ESC ô?
				{
					done=TRUE;				// ESC ˳ź
				}
				else						// ˳ʱˢĻ
				{
					DrawGLScene();				// Ƴ
					SwapBuffers(hDC);			//  (˫)
				}
			}
			if (keys[VK_F1])					// F1ô?
			{
				keys[VK_F1]=FALSE;				// ǣʹӦKeyеֵΪ FALSE
				KillGLWindow();					// ٵǰĴ
				fullscreen=!fullscreen;				// л ȫ /  ģʽ
				// ؽ OpenGL 
				if (!CreateGLWindow("OpenGL ",640,480,fullscreen))
				{
					return 0;				// δܴ˳
				}
			}
		}
	}
	// رճ
	KillGLWindow();								// ٴ
	return (msg.wParam);							// ˳
}
